diff --git a/src/main/listen.c b/src/main/listen.c
index 1edb72a9c2..07683429dd 100644
--- a/src/main/listen.c
+++ b/src/main/listen.c
@@ -77,10 +77,6 @@ static int command_write_magic(int newfd, listen_socket_t *sock);
 #endif
 #endif
 
-#ifdef WITH_COA_TUNNEL
-static int listen_coa_init(void);
-#endif
-
 static fr_protocol_t master_listen[];
 
 #ifdef WITH_DYNAMIC_CLIENTS
@@ -353,10 +349,6 @@ RADCLIENT *client_listener_find(rad_listen_t *listener,
 
 static int listen_bind(rad_listen_t *this);
 
-#ifdef WITH_COA_TUNNEL
-static void listener_coa_update(rad_listen_t *this, VALUE_PAIR *vps);
-#endif
-
 /*
  *	Process and reply to a server-status request.
  *	Like rad_authenticate and rad_accounting this should
@@ -420,10 +412,6 @@ int rad_status_server(REQUEST *request)
 		case RLM_MODULE_OK:
 		case RLM_MODULE_UPDATED:
 			request->reply->code = PW_CODE_ACCESS_ACCEPT;
-
-#ifdef WITH_COA_TUNNEL
-			if (request->listener->send_coa) listener_coa_update(request->listener, request->packet->vps);
-#endif
 			break;
 
 		case RLM_MODULE_FAIL:
@@ -451,10 +439,6 @@ int rad_status_server(REQUEST *request)
 		case RLM_MODULE_OK:
 		case RLM_MODULE_UPDATED:
 			request->reply->code = PW_CODE_ACCOUNTING_RESPONSE;
-
-#ifdef WITH_COA_TUNNEL
-			if (request->listener->send_coa) listener_coa_update(request->listener, request->packet->vps);
-#endif
 			break;
 
 		default:
@@ -868,39 +852,6 @@ static int dual_tcp_accept(rad_listen_t *listener)
 #endif
 	}
 
-#ifdef WITH_COA_TUNNEL
-	/*
-	 *	Originate CoA requests to a NAS.
-	 */
-	if (this->send_coa) {
-		home_server_t *home;
-
-		rad_assert(this->type != RAD_LISTEN_PROXY);
-
-		this->proxy_send = dual_tls_send_coa_request;
-		this->proxy_encode = master_listen[RAD_LISTEN_PROXY].encode;
-		this->proxy_decode = master_listen[RAD_LISTEN_PROXY].decode;
-
-		/*
-		 *	Automatically create a home server for this
-		 *	client.  There MAY be one already one for that
-		 *	IP in the configuration files, but it will not
-		 *	have this particular port.
-		 */
-		sock->home = home = talloc_zero(this, home_server_t);
-		home->ipaddr = sock->other_ipaddr;
-		home->port = sock->other_port;
-		home->proto = sock->proto;
-		home->secret = sock->client->secret;
-
-		home->coa_irt = this->coa_irt;
-		home->coa_mrt = this->coa_mrt;
-		home->coa_mrc = this->coa_mrc;
-		home->coa_mrd = this->coa_mrd;
-		home->recv_coa_server = this->server;
-	}
-#endif
-
 	/*
 	 *	FIXME: set O_NONBLOCK on the accept'd fd.
 	 *	See djb's portability rants for details.
@@ -963,12 +914,6 @@ int common_socket_print(rad_listen_t const *this, char *buffer, size_t bufsize)
 	}
 #endif
 
-#ifdef WITH_COA_TUNNEL
-	if (this->send_coa) {
-		ADDSTRING("+coa");
-	}
-#endif
-
 	if (sock->interface) {
 		ADDSTRING(" interface ");
 		ADDSTRING(sock->interface);
@@ -1104,16 +1049,6 @@ static CONF_PARSER limit_config[] = {
 	CONF_PARSER_TERMINATOR
 };
 
-#ifdef WITH_COA_TUNNEL
-static CONF_PARSER coa_config[] = {
-	{ "irt",  FR_CONF_OFFSET(PW_TYPE_INTEGER, rad_listen_t, coa_irt), STRINGIFY(2) },
-	{ "mrt",  FR_CONF_OFFSET(PW_TYPE_INTEGER, rad_listen_t, coa_mrt), STRINGIFY(16) },
-	{ "mrc",  FR_CONF_OFFSET(PW_TYPE_INTEGER, rad_listen_t, coa_mrc), STRINGIFY(5) },
-	{ "mrd",  FR_CONF_OFFSET(PW_TYPE_INTEGER, rad_listen_t, coa_mrd), STRINGIFY(30) },
-	CONF_PARSER_TERMINATOR
-};
-#endif
-
 #ifdef WITH_TCP
 /*
  *	TLS requires child threads to handle the listeners.  Which
@@ -1232,12 +1167,6 @@ int common_socket_parse(CONF_SECTION *cs, rad_listen_t *this)
 				return -1;
 			}
 
-			/*
-			 *	Add support for http://www.haproxy.org/download/1.8/doc/proxy-protocol.txt
-			 */
-			rcode = cf_item_parse(cs, "proxy_protocol", FR_ITEM_POINTER(PW_TYPE_BOOLEAN, &this->proxy_protocol), NULL);
-			if (rcode < 0) return -1;
-
 			/*
 			 *	If unset, set to default.
 			 */
@@ -1924,10 +1853,6 @@ static int do_proxy(REQUEST *request)
 	vp = fr_pair_find_by_num(request->config, PW_PACKET_DST_IP_ADDRESS, 0, TAG_ANY);
 	if (!vp) vp = fr_pair_find_by_num(request->config, PW_PACKET_DST_IPV6_ADDRESS, 0, TAG_ANY);
 
-#ifdef WITH_COA_TUNNEL
-	if (!vp) vp = fr_pair_find_by_num(request->config, PW_PROXY_TO_ORIGINATING_REALM, 0, TAG_ANY);
-#endif
-
 	if (!vp) return 0;
 
 	return 1;
@@ -3155,44 +3080,6 @@ rad_listen_t *proxy_new_listener(TALLOC_CTX *ctx, home_server_t *home, uint16_t
 
 		this->recv = proxy_tls_recv;
 		this->proxy_send = proxy_tls_send;
-
-#ifdef WITH_COA_TUNNEL
-		if (home->recv_coa) {
-			RADCLIENT *client;
-
-			this->send_coa = true;
-
-			/*
-			 *	Don't set this->send_coa, as we are
-			 *	not sending CoA-Request packets to
-			 *	this home server.  Instead, we are
-			 *	receiving CoA packets from this home
-			 *	server.
-			 */
-			this->send = proxy_tls_send_reply;
-			this->encode = master_listen[RAD_LISTEN_AUTH].encode;
-			this->decode = master_listen[RAD_LISTEN_AUTH].decode;
-
-			/*
-			 *	Automatically create a client for this
-			 *	home server.  There MAY be one already
-			 *	one for that IP in the configuration
-			 *	files, but there's no guarantee that
-			 *	it exists.
-			 *
-			 *	The only real reason to use an
-			 *	existing client is to track various
-			 *	statistics.
-			 */
-			sock->client = client = talloc_zero(sock, RADCLIENT);
-			client->ipaddr = sock->other_ipaddr;
-			client->src_ipaddr = sock->my_ipaddr;
-			client->longname = client->shortname = talloc_typed_strdup(client, home->name);
-			client->secret = talloc_typed_strdup(client, home->secret);
-			client->nas_type = "none";
-			client->server = talloc_typed_strdup(client, home->recv_coa_server);
-		}
-#endif
 	}
 #endif
 #endif
@@ -3239,15 +3126,9 @@ static const FR_NAME_NUMBER listen_compare[] = {
 	{ "status",	RAD_LISTEN_NONE },
 #endif
 	{ "auth",	RAD_LISTEN_AUTH },
-#ifdef WITH_COA_TUNNEL
-	{ "auth+coa",	RAD_LISTEN_AUTH },
-#endif
 #ifdef WITH_ACCOUNTING
 	{ "acct",	RAD_LISTEN_ACCT },
 	{ "auth+acct",	RAD_LISTEN_AUTH },
-#ifdef WITH_COA_TUNNEL
-	{ "auth+acct+coa",	RAD_LISTEN_AUTH },
-#endif
 #endif
 #ifdef WITH_DETAIL
 	{ "detail",	RAD_LISTEN_DETAIL },
@@ -3402,13 +3283,6 @@ static rad_listen_t *listen_parse(CONF_SECTION *cs, char const *server)
 	if (p) {
 		if (strncmp(p + 1, "acct", 4) == 0) {
 			this->dual = true;
-#ifdef WITH_COA_TUNNEL
-			p += 5;
-		}
-
-		if (strcmp(p, "+coa") == 0) {
-			this->send_coa = true;
-#endif
 		}
 	}
 #endif
@@ -3429,44 +3303,6 @@ static rad_listen_t *listen_parse(CONF_SECTION *cs, char const *server)
 		return NULL;
 	}
 
-#ifdef WITH_COA_TUNNEL
-	if (this->send_coa) {
-		CONF_SECTION	*coa;
-
-		if (!this->tls) {
-			cf_log_err_cs(cs, "TLS is required in order to use \"+coa\"");
-			listen_free(&this);
-			return NULL;
-		}
-
-		/*
-		 *	Parse the configuration if it exists.
-		 */
-		coa = cf_section_sub_find(cs, "coa");
-		if (coa) {
-			rcode = cf_section_parse(cs, this, coa_config);
-			if (rcode < 0) {
-				listen_free(&this);
-				return NULL;
-			}
-		}
-
-		/*
-		 *	Use the same boundary checks as for home
-		 *	server. See realm_home_server_sanitize().
-		 */
-		FR_INTEGER_BOUND_CHECK("coa_irt", this->coa_irt, >=, 1);
-		FR_INTEGER_BOUND_CHECK("coa_irt", this->coa_irt, <=, 5);
-
-		FR_INTEGER_BOUND_CHECK("coa_mrc", this->coa_mrc, <=, 20);
-
-		FR_INTEGER_BOUND_CHECK("coa_mrt", this->coa_mrt, <=, 30);
-
-		FR_INTEGER_BOUND_CHECK("coa_mrd", this->coa_mrd, >=, 5);
-		FR_INTEGER_BOUND_CHECK("coa_mrd", this->coa_mrd, <=, 60);
-	}
-#endif	/* WITH_COA_TUNNEL */
-
 	cf_log_info(cs, "}");
 
 	return this;
@@ -3773,10 +3609,6 @@ add_sockets:
 	 */
 	if (!*head) return -1;
 
-#ifdef WITH_COA_TUNNEL
-	if (listen_coa_init() < 0) return -1;
-#endif
-
 	return 0;
 }
 
@@ -3862,334 +3694,3 @@ rad_listen_t *listener_find_byipaddr(fr_ipaddr_t const *ipaddr, uint16_t port, i
 
 	return NULL;
 }
-
-#ifdef WITH_COA_TUNNEL
-/*
- *	This is easier than putting ifdef's everywhere.  And
- *	realistically, there aren't many systems which have OpenSSL,
- *	but not pthreads.
- */
-#ifndef HAVE_PTHREAD_H
-#error CoA tunnels require pthreads
-#endif
-
-#include <pthread.h>
-
-static rbtree_t *coa_tree = NULL;
-
-/*
- *	We have an RB tree of keys, and within each key, a hash table
- *	of one or more listeners associated with that key.
- */
-typedef struct {
-	char const     	*key;
-	fr_hash_table_t	*ht;
-
-	pthread_mutex_t	mutex;		/* per key, to lower contention */
-} coa_key_t;
-
-typedef struct {
-	coa_key_t	*coa_key;
-	rad_listen_t	*listener;
-} coa_entry_t;
-
-static int coa_key_cmp(void const *one, void const *two)
-{
-	coa_key_t const *a = one;
-	coa_key_t const *b = two;
-
-	return strcmp(a->key, b->key);
-}
-
-static void coa_key_free(void *data)
-{
-	coa_key_t *coa_key = data;
-
-	pthread_mutex_destroy(&coa_key->mutex);
-	fr_hash_table_free(coa_key->ht);
-	talloc_free(coa_key);
-}
-
-static uint32_t coa_entry_hash(void const *data)
-{
-	coa_entry_t const *a = (coa_entry_t const *) data;
-
-	return fr_hash(&a->listener, sizeof(a->listener));
-}
-
-static int coa_entry_cmp(void const *one, void const *two)
-{
-	coa_entry_t const *a = one;
-	coa_entry_t const *b = two;
-
-	return memcmp(&a->listener, &b->listener, sizeof(a->listener));
-}
-
-/*
- *	Delete the entry, without holding the parents lock.
- */
-static void coa_entry_free(void *data)
-{
-	talloc_free(data);
-}
-
-static int coa_entry_destructor(coa_entry_t *entry)
-{
-	pthread_mutex_lock(&entry->coa_key->mutex);
-	fr_hash_table_delete(entry->coa_key->ht, entry);
-	pthread_mutex_unlock(&entry->coa_key->mutex);
-
-	return 0;
-}
-
-static int listen_coa_init(void)
-{
-	/*
-	 *	We will be looking up listeners by key.  Each key
-	 *	points us to a list of listeners.  Each key has it's
-	 *	own mutex, so that it's thread-safe.
-	 */
-	coa_tree = rbtree_create(NULL, coa_key_cmp, coa_key_free, RBTREE_FLAG_LOCK);
-	if (!coa_tree) {
-		ERROR("Failed creating internal tracking tree for Originating-Realm-Key");
-		return -1;
-	}
-
-	return 0;
-}
-
-void listen_coa_free(void)
-{
-	/*
-	 *	If we are freeing the tree, then all of the listeners
-	 *	must have been freed first.
-	 */
-	rad_assert(rbtree_num_elements(coa_tree) == 0);
-	rbtree_free(coa_tree);
-	coa_tree = NULL;
-}
-
-/*
- *	Adds a listener to the hash of listeners, based on key.
- */
-void listen_coa_add(rad_listen_t *this, char const *key)
-{
-	int tries = 0;
-	coa_key_t my_key, *coa_key;
-	coa_entry_t *entry;
-
-	rad_assert(this->send_coa);
-	rad_assert(this->parent);
-	rad_assert(!this->key);
-
-	/*
-	 *	Find the key.  If we can't find it, then create it.
-	 */
-	my_key.key = key;
-
-retry:
-	coa_key = rbtree_finddata(coa_tree, &my_key);
-	if (!coa_key) {
-		coa_key = talloc_zero(NULL, coa_key_t);
-		if (!coa_key) return;
-		coa_key->key = talloc_strdup(coa_key, key);
-		if (!coa_key->key) {
-		fail:
-			talloc_free(coa_key);
-			return;
-		}
-
-		/*
-		 *	Create the hash table of listeners.
-		 */
-		coa_key->ht = fr_hash_table_create(coa_entry_hash, coa_entry_cmp, coa_entry_free);
-		if (!coa_key->ht) goto fail;
-
-		if (!rbtree_insert(coa_tree, coa_key)) {
-			talloc_free(coa_key);
-
-			/*
-			 *	The lookups are mutex protected, but
-			 *	if there's time between the lookup and
-			 *	the insert, another thread may have
-			 *	created the node.  In which case we
-			 *	try again.
-			 */
-			if (tries < 3) goto retry;
-			tries++;
-			return;
-		}
-
-		(void) pthread_mutex_init(&coa_key->mutex, NULL);
-	}
-
-	/*
-	 *	No need to strdup() this, coa_key will only be removed
-	 *	after the listener has been removed.
-	 */
-	if (!this->key) this->key = coa_key->key;
-
-	entry = talloc_zero(this, coa_entry_t);
-	if (!entry) return;
-	talloc_set_destructor(entry, coa_entry_destructor);
-
-	entry->coa_key = coa_key;
-	entry->listener = this;
-
-	/*
-	 *	Insert the entry into the hash table.
-	 */
-	pthread_mutex_lock(&coa_key->mutex);
-	fr_hash_table_insert(coa_key->ht, entry);
-	pthread_mutex_unlock(&coa_key->mutex);
-}
-
-/*
- *	Find an active listener by key.
- *
- *	This function will update request->home_server, and
- *	request->proxy_listener.
- */
-int listen_coa_find(REQUEST *request, char const *key)
-{
-	coa_key_t my_key, *coa_key;
-	rad_listen_t *this, *found;
-	listen_socket_t *sock;
-	fr_hash_iter_t iter;
-
-	/*
-	 *	Find the key.  If we can't find it, then error out.
-	 */
-	memcpy(&my_key.key, &key, sizeof(key)); /* const issues */
-	coa_key = rbtree_finddata(coa_tree, &my_key);
-	if (!coa_key) return -1;
-
-	/*
-	 *	We've found it.  Now find a listener which has free
-	 *	IDs.  i.e. where the number of used IDs is less tahn
-	 *	256.
-	 */
-	found = NULL;
-	pthread_mutex_lock(&coa_key->mutex);
-	for (this = fr_hash_table_iter_init(coa_key->ht, &iter);
-	     this != NULL;
-	     this = fr_hash_table_iter_next(coa_key->ht, &iter)) {
-		if (this->dead) continue;
-
-		if (!found) {
-			if (this->num_ids_used < 256) {
-				found = this;
-			}
-
-			/*
-			 *	Skip listeners which have all used IDs.
-			 */
-			continue;
-		}
-
-		/*
-		 *	Try to spread the load across all available
-		 *	sockets.
-		 */
-		if (found->num_ids_used > this->num_ids_used) {
-			found = this;
-			continue;
-		}
-
-		/*
-		 *	If they are equal, pick one at random.
-		 *
-		 *	@todo - pick one with equal probability from
-		 *	among the ones with the same IDs used.  This
-		 *	algorithm prefers the first one.
-		 */
-		if (found->num_ids_used == this->num_ids_used) {
-			if ((fr_rand() & 0x01) == 0) {
-				found = this;
-				continue;
-			}
-		}
-	}
-
-	pthread_mutex_unlock(&coa_key->mutex);
-	if (!found) return -1;
-
-	request->proxy_listener = found;
-
-	sock = found->data;
-	request->home_server = sock->home;
-	return 0;
-}
-
-/*
- *	Check for an active listener by key.
- */
-static bool listen_coa_exists(rad_listen_t *this, char const *key)
-{
-	coa_key_t my_key, *coa_key;
-	coa_entry_t my_entry, *entry;
-
-	/*
-	 *	Find the key.  If we can't find it, then error out.
-	 */
-	memcpy(&my_key.key, &key, sizeof(key)); /* const issues */
-	coa_key = rbtree_finddata(coa_tree, &my_key);
-	if (!coa_key) return false;
-
-	my_entry.listener = this;
-	pthread_mutex_lock(&coa_key->mutex);
-	entry = fr_hash_table_finddata(coa_key->ht, &my_entry);
-	pthread_mutex_unlock(&coa_key->mutex);
-
-	return (entry != NULL);
-}
-
-/*
- *	Delete a listener entry.
- */
-static void listen_coa_delete(rad_listen_t *this, char const *key)
-{
-	coa_key_t my_key, *coa_key;
-	coa_entry_t my_entry;
-
-	/*
-	 *	Find the key.  If we can't find it, then error out.
-	 */
-	memcpy(&my_key.key, &key, sizeof(key)); /* const issues */
-	coa_key = rbtree_finddata(coa_tree, &my_key);
-	if (!coa_key) return;
-
-	my_entry.listener = this;
-	pthread_mutex_lock(&coa_key->mutex);
-	(void) fr_hash_table_delete(coa_key->ht, &my_entry);
-	pthread_mutex_unlock(&coa_key->mutex);
-}
-
-
-static void listener_coa_update(rad_listen_t *this, VALUE_PAIR *vps)
-{
-	VALUE_PAIR *vp;
-	vp_cursor_t cursor;
-
-	fr_cursor_init(&cursor, &vps);
-
-	/*
-	 *	Add or delete Operator-Name realms
-	 */
-	while ((vp = fr_cursor_next_by_num(&cursor, PW_OPERATOR_NAME, 0, TAG_ANY)) != NULL) {
-		if (vp->vp_length <= 1) continue;
-
-		if (vp->vp_strvalue[0] == '+') {
-			if (listen_coa_exists(this, vp->vp_strvalue)) continue;
-
-			listen_coa_add(this, vp->vp_strvalue);
-			continue;
-		}
-
-		if (vp->vp_strvalue[0] == '-') {
-			listen_coa_delete(this, vp->vp_strvalue);
-			continue;
-		}
-	}
-}
-#endif
diff --git a/src/main/mainconfig.c b/src/main/mainconfig.c
index 09799da0e2..b134712356 100644
--- a/src/main/mainconfig.c
+++ b/src/main/mainconfig.c
@@ -509,16 +509,6 @@ static ssize_t xlat_listen_common(REQUEST *request, rad_listen_t *listen,
 	}
 #endif
 
-#ifdef WITH_COA_TUNNEL
-	/*
-	 *      Look for RADSEC CoA tunnel key.
-	 */
-	if (listen->key && (strcmp(fmt, "Originating-Realm-Key") == 0)) {
-		strlcpy(out, listen->key, outlen);
-		return strlen(out);
-	}
-#endif
-
 	cp = cf_pair_find(listen->cs, fmt);
 	if (!cp || !(value = cf_pair_value(cp))) {
 		RDEBUG("Listener does not contain config item \"%s\"", fmt);
diff --git a/src/main/modules.c b/src/main/modules.c
index 9919482c86..e18977d34f 100644
--- a/src/main/modules.c
+++ b/src/main/modules.c
@@ -1357,7 +1357,7 @@ static int load_byserver(CONF_SECTION *cs)
 	 *	This is a bit of a hack...
 	 */
 	if (!found) do {
-#if defined(WITH_VMPS) || defined(WITH_DHCP)
+#if defined(WITH_VMPS) || defined(WITH_DHCP) || defined(WITH_TLS)
 		CONF_SECTION *subcs;
 #endif
 #if defined(WITH_DHCP) || defined(WITH_TLS)
